#
#
# dbus_signal_handler.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
from blueman.Main.signal_handler import signal_handler


class dbus_signal_handler(signal_handler):

	def __init__(self, sig_class):
		signal_handler.__init__(self, sig_class)
		#@self.__signals = {}
		#self.__class = sig_class
		
		Globals.dbg.info("Initializing 'Main.dbus_signal_handler' Class", 6)

		
	def connect(self, name, handler):
		id = self._class.connect_to_signal(name, handler)
		self._signals[name] = id
		Globals.dbg.info("Connecting dbus Signal '%s'" % name, 7)
		
	def disconnect(self, name):
		Globals.dbg.info("Disconnecting dbus Signal '%s'" % name, 7)
		self._signals[name].remove()

