#
#
# autostart_polkit.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import os
import re
import blueman.Globals as Globals
from blueman.Services.autostart import autostart
from blueman.Main.polkit_auth import polkit_auth
from blueman.Main.mechanism import mechanism

class autostart_polkit(autostart):

	def __init__(self, id, widget):
		autostart.__init__(self, id)
		self.widget = widget
		
		self.auth = polkit_auth()
		self.mechanism = mechanism()

	def toggle(self, state):
		
		
		if not self.auth.is_authorized("org.blueman.autostart"):
			granted = self.auth.obtain_authorization(self.widget, "org.blueman.autostart")
		else:
			granted = True
			
		if granted:
			
			status = self.mechanism.AutostartManager(self.service, state)
			if status:
				return True
			else:
				return False
			print "granted"
		
		else:
			return False
	
	def enable(self):
		return self.toggle(True)
		
	def disable(self):
		return self.toggle(False)

