#
#
# server.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals


from blueman.Services.bluetooth.Transfer.session import session

class server_session(session):

	def __init__(self, server, path, profile):
		self.server = server
		session.__init__(self, path, "org.openobex.ServerSession")
		self.profile = profile

		
	def get_remote_address(self):
		_dict = self.server.GetServerSessionInfo(self.path)
		if "BluetoothAddress" in _dict:
			return _dict["BluetoothAddress"]
		else:
			return None
			
	def transfer_started(self, filename, local_path, total_bytes):		
		
		if (Globals.Settings.trans_opp_trustedonly and self.profile=="opp") or (Globals.Settings.trans_ftp_trustedonly and self.profile=="ftp"):
			addr = self.get_remote_address()
			if not Globals.adapter.IsTrusted(addr):
				self.session.Reject()
				print "rejecting"
			else:
				self.session.Accept()
				print "accepting"
		else:
			self.session.Accept()
			print "accepting"
				
		session.transfer_started(self, filename, local_path, total_bytes);
		
	def cancelled(self):
		session.cancelled(self)
		self.ses_disconnect()

			
			
			
			
			
