#
#
# transfer.py
# (c) 2007 Valmantas Paliksa <walmis at balticum-tv dot lt>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

import blueman.Globals as Globals
import gobject
import dbus


from blueman.Services.bluetooth.Transfer.manager import manager

class transfer(gobject.GObject):
	__gsignals__ = {
		'service-started' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()),
		'service-stopped' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()),
	}
	def __init__(self):
		gobject.GObject.__init__(self)
		
		self.g_man_signal = None
		self.manager = None
		
		if Globals.Settings.transfer_autostart:
			self.manager = manager()
			self.g_man_signal = self.manager.connect("manager-closed", self._manager_closed)
			


	def is_running(self):
		if self.manager != None:
			return True
		else:
			return False
		
	def stop(self):
		if self.manager != None:
			self.manager.__deinit__()

	
	def start(self):
		self.manager = manager()
		self.g_man_signal = self.manager.connect("manager-closed", self._manager_closed)
		self.emit("service-started")
	
	def _manager_closed(self, manager):
		Globals.dbg.info("Transfer manager closed", 7)
		manager.disconnect(self.g_man_signal)
		del self.manager
		self.manager = None
		
		self.emit("service-stopped")
			
		
