from blueman.Gui.generic_tree import generic_tree
class transfer_monitor:

	def __init__(self):
				## pixbuffs
		
		self.idle_pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR+"/idle.png")
		self.transfer_pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR+"/transfer.png")
		self.idle_pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR+"/idle.png")
		self.server_pb = gtk.gdk.pixbuf_new_from_file(Globals.IMAGE_DIR+"/server.png")



		sw = self.xml.get_widget("sw_mon")
		
		self.num_sessions = {"opp":0, "ftp":0}
				
		self.server_iters = {}
		self.session_iters = {}
		
		self.gsignals = []
		
		self.g_server_signals = {}
		self.g_session_signals = {}
		
		
		cr = gtk.CellRendererProgress()
		cr.props.xpad = 15
		cr.props.ypad = 15
		data = [
			["icon", 'GdkPixbuf', gtk.CellRendererPixbuf(), {"pixbuf":0, "stock-size": 3}, ""],
			["text", str, gtk.CellRendererText(), {"markup":1}, ""],
			["progress", int, cr, {"value":2, "visible":4, "text":5}, ""],
			["ic_size", int],
			["pr_visible", bool],
			["pr_text", str],
			["total_bytes", int],
			["bytes_transferred", int], 
			["server", str],
			["address", str],
			["name", str],
			["status", str],
			["filename", str],
			["local_path", str]

		]
		
		self.mon_tree = generic_tree(data)
		self.mon_tree.set_headers_visible(False)
		
		sw.add(self.mon_tree)
		self.mon_tree.show()

	def add_server(self, profile):
		iter = self.mon_tree.add(None, 
			pr_visible=False,
			progress=0,
			ic_size=gtk.ICON_SIZE_DIALOG,
			icon=self.server_pb,
			server=profile.upper(),
			text="<b>%s Server</b>\n<span size='x-small'>Clients: %s\nTransfers: %s</span>" % (profile.upper(), 0, 0))
			
		self.server_iters[profile] = iter
		
	def rem_server(self, profile):
		self.mon_tree.delete(self.server_iters[profile])
		
	### add/remove session ###
	def add_session(self, address, profile, id):
		print "adding session %s %s" % (profile, address)
		parent = self.server_iters[profile]
		
		
		
		iter = self.mon_tree.add(parent, 
			pr_visible=False,
			progress=0,
			ic_size=gtk.ICON_SIZE_MENU,
			icon=self.idle_pb,
			server=profile.upper(),
			text=self.make_tree_session_text("TODO:walmis", address, "Idle"),
			address=address,
			name="todo"
		)

		self.session_iters[id] = iter
	

	def rem_session(self, address, profile, id):
		iter = self.session_iters[id]
		self.mon_tree.delete(iter)
	############################

			
	
	def make_tree_session_text(self, name, address, status):
		return "<span size='xx-small'>%s\n%s</span>\n<i>%s</i>" % (address, name, status)	
		
	def tree_transfer_start(self, id, bytes, local_path, filename):
		iter = self.session_iters[id]
		row = self.mon_tree.get(iter, "name", "address")
		if bytes < 0:
			text = self.make_tree_session_text(row["name"], row["address"], "Uploading")
			vis = False
			bytes = 0
		else:
			text= self.make_tree_session_text(row["name"], row["address"], "Transferring")
			vis = True

		
		self.mon_tree.set(iter, pr_visible=vis,
					total_bytes=bytes,
					local_path=local_path,
					filename=filename,
					text=text,
					icon=self.transfer_pb
				 )
				 
	def tree_transfer_stop(self, id):
		iter = self.session_iters[id]
		row = self.mon_tree.get(iter, "name", "address")
		self.mon_tree.set(iter, pr_visible=False,
					total_bytes=0,
					local_path="",
					filename="",
					icon=self.idle_pb,
					text=self.make_tree_session_text(row["name"], row["address"], "Idle"))
	
	def tree_transfer_progress(self, id, bytes):
		iter = self.session_iters[id]
		
		row = self.mon_tree.get(iter, "name", "address","total_bytes")
		if row["total_bytes"] > 0:
			percent = bytes / float(row["total_bytes"]) * 100
			self.mon_tree.set(iter, bytes_transferred=bytes, progress=percent, pr_text=None )		

	
	
	def update_monitor_tree(self):
		pass 	
		
		
		
	###### SESSION SIGNALS #######

	def ses_cancelled(self, session):
		print "g ses cancelled"
		self.tree_transfer_stop(session.id)
		
	def ses_disconnected(self, session):
		print "g ses disconnected"
		self.tree_transfer_stop(session.id)
		
	def ses_transfer_progress(self, session, bytes):
		#print "g transfer progress"

		self.tree_transfer_progress(session.id, bytes)
	
	def ses_transfer_started(self, session, filename, local_path, total_bytes):
		print "g transfer started"
		self.tree_transfer_start(session.id, total_bytes, filename, local_path)
				
	def ses_transfer_completed(self, session):
		print "g transfer completed"
		self.tree_transfer_stop(session.id)
		
	def ses_error_ocurred(self, session, err, msg):
		print "g error occurred"
	
	
	
	
	##############################
	
	
	##### SERVER SIGNALS #####
	def session_created(self, server, address, id):
		self.add_session(address, server.profile, id)
		
		ses = server.get_session_by_id(id)
		print ses
		signals = signal_handler(ses)
		signals.connect("transfer-started", self.ses_transfer_started)
		signals.connect("cancelled", self.ses_cancelled)
		signals.connect("disconnected", self.ses_disconnected)
		signals.connect("transfer-progress", self.ses_transfer_progress)
		signals.connect("transfer-completed", self.ses_transfer_completed)
		signals.connect("error-occurred", self.ses_error_ocurred)
		
		self.g_session_signals[id] = signals
		
	def session_ended(self, server, address, id):
		print "g session ended"
		signals = self.g_session_signals[id]
		signals.deinit()
		del self.g_session_signals[id]
		
		self.rem_session(address, server.profile, id)
		
	def server_started(self, server):
		pass
	
	def server_stopped(self, server):
		pass
	
	
	##########################
	
	###### MANAGER SIGNALS #####
	def manager_closed(self, manager):
		print "g manager closed"
		
	def server_created(self, manager, profile):
		print "g server_created %s" % profile
		server = self.service.manager.get_server(profile)
		handler = signal_handler(server)
		self.g_server_signals[server] = handler
		handler.connect("session-started", self.session_created)
		handler.connect("session-ended", self.session_ended)
		handler.connect("server-started", self.server_started)
		handler.connect("server-stopped", self.server_stopped)

		
		self.add_server(profile)
		
		
	def server_destroyed(self, manager, profile):
		print "g server_destroyed %s" % profile

	############################
