import blueman.Globals as Globals
_ = Globals._
#import gobject

from blueman.Main.signal_handler import signal_handler
from blueman.Services.autostart_polkit import autostart_polkit
from blueman.Services.autostart_transfer import autostart_transfer
import gtk

class generic():

	
	def __init__(self, id, glade_xml):
		#gobject.GObject.__init__(self)
		
		self.id = id
		self.xml = glade_xml
		
		#prefs button
		self.b = self.xml.get_widget("b_"+id)
		#stop/start button
		self.tb = self.xml.get_widget("tb_"+id)
		#label
		self.l = self.xml.get_widget("l_"+id)
		#autostart checkbutton
		self.cb = self.xml.get_widget("cb_"+id)
		self.bi = self.xml.get_widget("bi_"+id)
		self.i = self.xml.get_widget("i_"+id)
		
		self._g_inst_signal = None
		self._instance = None
		
		status = Globals.Services.get_service_status(id)
		self.set_state(status)
		
		
		self.sig_b = self.b.connect("clicked", self.preferences_clicked)
		self.sig_tb = self.tb.connect("toggled", self.on_service_toggled)
		self.sig_cb = self.cb.connect("toggled", self.on_autostart_toggled)

		
	def autostart_instance(self):
		if self.id == "transfer":
			return autostart_transfer()
		else:
			return autostart_polkit(self.id, self.b)
		
	def deinit(self):
		self.b.disconnect(self.sig_b)
		self.tb.disconnect(self.sig_tb)
		self.cb.disconnect(self.sig_cb)
	
	def preferences_clicked(self, widget):
		self.preferences()
	
	
	def on_service_toggled(self, widget):
		if widget.get_active():
			self._start()
		else:
			self._stop()		
		
	
	#virtual
	def _start(self):
		pass
	
	#virtual	
	def _stop(self):
		pass
	
	
	def _stopped(self):
		#self.emit("stopped")
		if self._instance != None:
			self._g_inst_signal.deinit()
			self._instance.__destroy__()
			
			self._instance = None
			self._g_inst_signal = None
			
		self.set_state(0)
		
	def _started(self):
		#self.emit("started")
		self.set_state(1)
	

	#virtual function
	def preferences(self):
		pass
		
	def run(self, inst):
		self._instance = inst
		self._g_inst_signal = signal_handler(inst)
		self._g_inst_signal.connect("dialog-destroyed", self.dialog_destroyed)
		
	def dialog_destroyed(self, dialog):
		self._g_inst_signal.deinit()
		
		self._instance = None
		self._g_inst_signal = None
		
	
	def set_state(self, state):
		ats=self.autostart_instance()
		autostarted = ats.is_enabled()

		

		if state == 1:
			self.b.set_sensitive(True)
			self.i.set_sensitive(True)
			if autostarted != None:
				self.cb.set_sensitive(True)
				self.cb.set_active(autostarted)
			
			self.tb.set_sensitive(True)
			self.tb.set_active(True)
			self.bi.set_from_stock(gtk.STOCK_YES, gtk.ICON_SIZE_BUTTON)

			
			self.l.set_sensitive(True)

		elif state == 0:
			if autostarted != None:
				self.cb.set_sensitive(True)
				self.cb.set_active(autostarted)
			
			self.b.set_sensitive(False)
			self.i.set_sensitive(False)
			
			self.tb.set_sensitive(True)
			self.tb.set_active(False)
			self.bi.set_from_stock(gtk.STOCK_NO, gtk.ICON_SIZE_BUTTON)
			
			self.l.set_sensitive(True)
		elif state == -1:
			self.i.set_sensitive(False)
			self.b.set_sensitive(False)
			self.tb.set_sensitive(False)
			self.l.set_sensitive(False)
			if autostarted != None:
				self.cb.set_sensitive(False)
			
	def on_autostart_toggled(self, widget):
		ats=self.autostart_instance()
		enabled = ats.is_enabled()
		
		if widget.get_active() and not enabled:
			if not ats.enable():
				widget.set_active(False)
		
		elif not widget.get_active() and enabled:
			if not ats.disable():
				widget.set_active(True)	
