import blueman.Globals as Globals

from blueman.Services.gui.network import network as network_service

from blueman.Services.service_manager.generic import generic

from blueman.Main.signal_handler import signal_handler


class network(generic):
	def __init__(self, glade_xml):
		generic.__init__(self, "network", glade_xml)
		
		service = Globals.Services.get(self.id)
		self.g_signals = None
		if service:		
			self.g_signals = signal_handler(service)
			self.g_signals.connect("service-started", self.service_started)
			self.g_signals.connect("service-stopped", self.service_stopped)
		
	def _start(self):
		Globals.Services.get("network").start()
	
	def _stop(self):
		Globals.Services.get("network").stop()

	def service_started(self, service):
		self._started()
		
	def service_stopped(self, service):
		self._stopped()
		
	def preferences(self):
		self.run(network_service())
		
	def deinit(self):
		generic.deinit(self)
		if self.g_signals:
			self.g_signals.deinit()
			del self.g_signals

