import blueman.Globals as Globals

from blueman.Services.gui.transfer import transfer as transfer_service

from blueman.Services.service_manager.generic import generic

from blueman.Main.signal_handler import signal_handler


class transfer(generic):
	def __init__(self, glade_xml):
		generic.__init__(self, "transfer", glade_xml)
		
		service = Globals.Services.get(self.id)
				
		self.g_signals = signal_handler(service)
		self.g_signals.connect("service-started", self.service_started)
		self.g_signals.connect("service-stopped", self.service_stopped)
		
	def _start(self):
		Globals.Services.get("transfer").start()
	
	def _stop(self):
		Globals.Services.get("transfer").stop()

	def service_started(self, service):
		self._started()
		
	def service_stopped(self, service):
		self._stopped()
		
	def preferences(self):
		self.run(transfer_service())
		
	def deinit(self):
		generic.deinit(self)
		self.g_signals.deinit()
		del self.g_signals

